#include "avr_compiler.h"
#include "port_driver.h"

void Example1( void );
void Example2( void );
void Example3( void );
void Example4( void );


int main( void )
{
	//Example1();
	//Example2();
	//Example3();
	Example4();

	while(true){

	}
	return 1;
}


/*  Getting started example 1.
 *
 *  This function implements the "Basic Digital I/O" example from the
 *  "Getting Started" section in the application note.
 *
 *  This function will continously read input from 8 switches connected to PORTC
 *  and output the pin state to 8 LEDs connected to PORTD.
 */
void Example1( void )
{
	// Configure data direction for PORTE. 
	PORT_SetPinsAsInput( &PORTE, 0x01 );
	PORT_SetPinsAsOutput( &PORTD, 0x02 );

	// Continously copy the value from PORTE.PE0 to PORTE.PE1. 
	do {
		uint8_t temp = PORT_GetPortValue( &PORTE ); 
		PORT_SetOutputValue( &PORTE, temp );
	} while (true);
}


/*  Getting started example 2.
 *
 *  This function implements the "Configuring Several Pins in One Operation"
 *  example from the "Getting Started" section in the application note.
 *
 *  This function configures pins 0-3 on PORTC for Wired-AND with pull-up
 *  operation.
 */
void Example2( void )
{
	PORT_ConfigurePins( &PORTC,
	                    0x0F,
	                    false,
	                    false,
	                    PORT_OPC_WIREDANDPULL_gc,
	                    PORT_ISC_BOTHEDGES_gc );
}


/*  Getting started example 3.
 *
 *  This function implements the "Mapping Real Ports to Virtual Ports" example
 *  from the "Getting Started" section in the application note.
 *
 *  This function maps PORTC to Virtual port 0 and PORTD to Virtual PORT1,
 *  and performs the same task as in Example1() using virtual ports.
 */
void Example3( void )
{
	// Map the ports. 
	PORT_MapVirtualPort0( PORTCFG_VP0MAP_PORTC_gc );
	PORT_MapVirtualPort1( PORTCFG_VP1MAP_PORTD_gc );

	// Configure VPORT0 as input and VPORT1 as output. 
	PORT_SetDirection( &VPORT0, 0x00 );
	PORT_SetDirection( &VPORT1, 0xFF );

	// Continously copy the value from PORTC to PORTD using the
	// virtual ports.
	 
	do {
		uint8_t temp = PORT_GetPortValue( &VPORT0 );
		PORT_SetOutputValue( &VPORT1, temp );
	} while (true);
}


/*  Getting started example 4.
 *
 *  This function implements the "Configuring an I/O Pin for Interrupt Generation"
 *  example from the "Getting Started" section in the application note.
 *
 *  This function configures PORTC interrupt0 as a medium level interrupt,
 *  triggered by the rising edge of PC0. The interrupt service routine toggles
 *  the output on PORTD.
 */
void Example4( void )
{
	// Configure PE0 as input, triggered on rising edge. 
	PORT_ConfigurePins( &PORTE,
	                    0x01,
	                    false,
	                    false,
	                    PORT_OPC_TOTEM_gc,
	                    PORT_ISC_RISING_gc );

	PORT_SetPinsAsInput( &PORTE, 0x01 );

	// Configure PORTE as output with the pattern 0x02. 
	PORT_SetPinsAsOutput( &PORTE, 0x02 );
	//PORT_SetPins( &PORTE, 0x02 );

	// Configure Interrupt0 to have medium interrupt level,
	// triggered by pin 0. 
	PORT_ConfigureInterrupt0( &PORTE, PORT_INT0LVL_MED_gc, 0x01 );

	// Enable medium level interrupts in the PMIC. 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;

	// Enable the global interrupt flag. 
	sei();
}


/*  Interrupt service routine for Example4()
 *
 *  When initialized using Example4(), this ISR is called on every rising edge
 *  on PC0.
 */
ISR(PORTE_INT0_vect)
{
	PORT_TogglePins( &PORTE, 0x02 );
}

